/**********************************************************************
**
** Copyright (C) 2003 Germain Garand <germain@ebooksfrance.org>
**
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
**********************************************************************/

#include <actioninterface.h>
#include <designerinterface.h>

struct DesignerInterface;

class ActionInterfaceImpl: public ActionInterface
{
public:
    ActionInterfaceImpl();
    virtual ~ActionInterfaceImpl();

    Q_REFCOUNT;

    QRESULT queryInterface( const QUuid&, QUnknownInterface** );

    QAction* create( const QString &name, QObject* parent = 0 );
    QString group( const QString &name ) const
    {
	Q_UNUSED( name )
	return "PerlQt";
    }
    bool location( const QString &name, Location l ) const
    {
	Q_UNUSED( name )
	Q_UNUSED( l )
	return true;
    }
    QStringList featureList() const;
    void connectTo( QUnknownInterface *appInterface ) { dIface = (DesignerInterface *) appInterface; }

private:
    DesignerInterface *dIface;
};
