/**********************************************************************
**
** Copyright (C) 2000 Trolltech AS.  All rights reserved.
**
** This file is part of Qt Designer.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/

#ifndef CLASSBROWSERINTERFACEIMPL_H
#define CLASSBROWSERINTERFACEIMPL_H

#include <classbrowserinterface.h>
#include <qguardedptr.h>
#include "objectbrowser.h"

class QWidget;

class ClassBrowserInterfaceImpl : public ClassBrowserInterface
{
public:
    ClassBrowserInterfaceImpl( QUnknownInterface *outer = 0 );
    virtual ~ClassBrowserInterfaceImpl();

    ulong addRef();
    ulong release();

    QRESULT queryInterface( const QUuid&, QUnknownInterface** );

    virtual QListView *createClassBrowser( QWidget *p ) const;
    virtual void update( const QString &code ) const;
    virtual void clear() const;
    virtual void onClick( QObject *receiver, const char *slot );

    QObject *getReceiver() const { return m_receiver; }
    const char *getSlot() const { return m_slot; }
    void setObjectBrowser( PerlQtObjectBrowser* ob ) { m_ob = ob; }
    PerlQtObjectBrowser* objectBrowser( ) const { return m_ob; }

private:
    QUnknownInterface *parent;
    int ref;
    QGuardedPtr<PerlQtObjectBrowser> m_ob;
    QObject *m_receiver;
    const char *m_slot;

};

#endif

