#ifndef PERLACTION_H
#define PERLACTION_H
/**********************************************************************
**
** Copyright (C) 2003 Germain Garand <germain@ebooksfrance.org>
**
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
**********************************************************************/

#include <qaction.h>
#include <qmessagebox.h>
#include <qfile.h>
#include <qprocess.h>
#include <designerinterface.h>
#include "conf.h"

class PerlAction: public QAction
{
    Q_OBJECT

public:
    enum Type { RunForm, RunProject };

    PerlAction( QObject* p, DesignerInterface* d, int t );
    virtual ~PerlAction();

protected slots:
    void outputStdout();
    void outputStderr();
    void processTerminated();
    void runForm();
    void runProject();

private:
    bool checkProcess();
    DesignerInterface* dIface;
    static QProcess* perl_process;
};

#endif

