/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
** 
** Add custom slot implementations here. Use a slot init() for
** initialization code called during construction, and a slot destroy()
** for cleanup code called during destruction.
**
** This file gets modified by Qt Designer whenever you add, rename or
** remove custom slots. Implementation code does not get lost.
*****************************************************************************/

#include <designerinterface.h>
#include <qfiledialog.h>

void PerlProjectSettings::reInit( QUnknownInterface *iface )
{
    
    DesignerInterface *dIface = 0;
    iface->queryInterface( IID_Designer, (QUnknownInterface**)&dIface );
    if ( !dIface )
	return;
    DesignerProject *project = dIface->currentProject();
    QStringList l = project->formNames();
    listForms->clear();
    listForms->insertStringList( l );
    if( ! listForms->count() )
	listForms->insertItem( "Form1" );
    listForms->setCurrentItem( 0 );
    
    if( !project->customSetting("PROGRAM_NAME").isEmpty() )
        editFileName->setText( project->customSetting("PROGRAM_NAME") );
    else
        editFileName->setText( "main.pl" );
    if( !project->customSetting( "MAIN_FORM" ).isEmpty() )
    {
	int ix = l.findIndex( project->customSetting("MAIN_FORM") );
	if( ix != -1 )
	{
	    listForms->setCurrentItem( ix );
	}
    }
    else
    {
	radioGenerate->setChecked( false );
    }
    editFileName->setFocus();
    editFileName->selectAll();
}

void PerlProjectSettings::save( QUnknownInterface *iface )
{
    DesignerInterface *dIface = 0;
    iface->queryInterface( IID_Designer, (QUnknownInterface**)&dIface );
    if ( !dIface )
	return;
    DesignerProject *project = dIface->currentProject();
    if( ! editFileName->text().isEmpty() )
	project->setCustomSetting( "PROGRAM_NAME", editFileName->text() );
    if( radioGenerate->isChecked() )
	project->setCustomSetting("MAIN_FORM", listForms->currentText() );
    else
	project->setCustomSetting("MAIN_FORM", QString::null );
}
